#include "ofApp.h"



//--------------------------------------------------------------
void ofApp::setup(){
	ofEnableSmoothing();
	ofBackground(0);

	par.standardSetup();
}

//--------------------------------------------------------------
void ofApp::update(){

	par.standardUpdate();
}

//--------------------------------------------------------------
void ofApp::draw(){

	par.standardDraw();
}

//--------------------------------------------------------------
void ofApp::keyPressed(int key){

}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){
	 switch (key) {
		case '1':
			ofLogNotice() << "AppState::IDLE";
			this->par.setState(AppState::IDLE);
            break;
        case '2':
			ofLogNotice() << "AppState::CONFIGINFRA";
			this->par.setState(AppState::CONFIGINFRA);
            break;
		case '3':
			ofLogNotice() << "AppState::PLAY";
			this->par.setState(AppState::PLAY);
            break;
		case OF_KEY_F12:
            ofToggleFullscreen();
            break;
		case 's':
			par.m_infra->getCamera().videoSettings();
			break;
		case 'f': //stop to draw video feed;
			par.m_infra->toogleVideoFeed();
			break;
		case 'c':
			//if(par.controlManager.doControlDetection == false) {
			//	par.controlManager.reset();
			//	par.controlManager.doControlDetection == true;
			//}
			par.controlManager.reset();
			par.controlManager.toogleControlDetection();
			break;
		case 'd':
			par.debug == true ? par.debug = false : par.debug = true;
			break;
		case 'r':
			if(par.getActualState()->stateType == AppState::CONFIGINFRA){ par.m_infra->resetCalibration(); }
			break;
        default:
            break;
    }
}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){
	if ( par.getActualState()->stateType == AppState::CONFIGINFRA) {
		par.m_infra->addCalibrationPoints(x,y);
	}

}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 

}
