///////////////////////////////////////////////////////////
//  ofxPAR_Actuator.h
//  Implementation of the Class ofxPAR_Actuator
//  Created on:      14-fev-2015 00:11:57
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#if !defined(EA_E7F79A77_2901_45be_90F8_607E11E77280__INCLUDED_)
#define EA_E7F79A77_2901_45be_90F8_607E11E77280__INCLUDED_

#include "ofMain.h"
#include "ofxCv.h"

class ofxPAR_Actuator
{

public:
	ofxPAR_Actuator();
	virtual ~ofxPAR_Actuator();

	virtual void draw() = 0;
	virtual void drawDetectorInput(float x, float y, float w, float h) = 0;

    template <class T, class S>
    bool detect(const T &top, const S &side, const ofPolyline &paper) {
        return detect(ofxCv::toCv(top), ofxCv::toCv(side), paper);
    }
    virtual bool detect(const cv::Mat &top, const ofPolyline &paper) = 0;
    
    virtual ofPoint getActuatorPoint() = 0;
	virtual void setActuatorThresold(int value)  = 0;

	ofxCv::RunningBackground topBackground;
    cv::Mat foreground;
protected: 
	 


};
#endif // !defined(EA_E7F79A77_2901_45be_90F8_607E11E77280__INCLUDED_)
