///////////////////////////////////////////////////////////
//  ofxPAR_C_Button.cpp
//  Implementation of the Class ofxPAR_C_Button
//  Created on:      14-fev-2015 00:12:02
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#include "ofxPAR_C_Button.h"


ofxPAR_C_Button::ofxPAR_C_Button() {
	controlType = ControlType::PAR_BUTTON;
	value = 0;

}



ofxPAR_C_Button::~ofxPAR_C_Button(){

}



//---------------------------------------------------------
ofxPAR_C_Button::ofxPAR_C_Button(float x, float y, float r)
  : ofxPAR_Control() {

	  controlType = ControlType::PAR_BUTTON;
    cx = x;
    cy = y;

    radius = r;
    active = false;
    entered = false;
}

//---------------------------------------------------------
void ofxPAR_C_Button::draw() {
	ofPushMatrix();
		ofSetColor(color);
		ofSetLineWidth(5);
		if (active) {
			ofFill();
		} else {
			ofNoFill();
		}
		ofCircle(cx, cy, radius);
	ofPopMatrix();
}

//---------------------------------------------------------
bool ofxPAR_C_Button::contains(float x, float y) {
    return ofDistSquared(cx, cy, x, y) < radius * radius;
}

//---------------------------------------------------------
bool ofxPAR_C_Button::onInteraction(float x, float y) {
    if (contains(x, y)) {
        if (!entered) {
            entered = true;
            active = true;
        }
        return true;
    } else if (entered) {
        active = false;
        entered = false;

        return true;
    }

    return false;
}

//---------------------------------------------------------
bool ofxPAR_C_Button::operator==(const ofxPAR_C_Button &other) {
    // TODO Define constants for thresholds
    return (abs(other.cx - cx) < 10)
        && (abs(other.cy - cy) < 10)
        && (abs(other.radius - radius) < 10);
};