///////////////////////////////////////////////////////////
//  ofxPAR_C_Switch.cpp
//  Implementation of the Class ofxPAR_C_Switch
//  Created on:      14-fev-2015 00:12:03
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#include "ofxPAR_C_Switch.h"


ofxPAR_C_Switch::ofxPAR_C_Switch(){
	controlType = ControlType::PAR_SWITCH;
	value = 0;

}



ofxPAR_C_Switch::~ofxPAR_C_Switch(){

}



//---------------------------------------------------------
ofxPAR_C_Switch::ofxPAR_C_Switch(const cv::RotatedRect &rotRect) 
  : ofxPAR_Control_Rectangular(rotRect) {
      active = false;
	  controlType = ControlType::PAR_SWITCH;
}

//---------------------------------------------------------
void ofxPAR_C_Switch::draw() {
    ofPushMatrix();
    ofTranslate(rect.getCenter());
    ofRotate(angle);

    ofNoFill();
    ofSetLineWidth(3);
    ofSetColor(color);

    ofRect(-rect.width / 2, -rect.height / 2, rect.width, rect.height);
    ofLine(0, -rect.height / 2, 0, rect.height / 2);

    float x = (active ? 0 : -rect.width / 2);
    ofLine(x, -rect.height / 2, x + rect.width / 2, rect.height / 2);
    ofLine(x + rect.width / 2, -rect.height / 2, x, rect.height / 2);

    ofPopMatrix();
}


//---------------------------------------------------------
bool ofxPAR_C_Switch::onInteraction(float x, float y) {
    if (contains(x, y)) {
        ofVec2f pt = alignPoint(x, y);
        bool right = pt.x > rect.getCenter().x;

        if (active != right) {
            active = right;
           // sender.sendToggleValue(id, active);
        }
        return true;
    }

    return false;
}
