///////////////////////////////////////////////////////////
//  ofxPAR_Control.h
//  Implementation of the Class ofxPAR_Control
//  Created on:      14-fev-2015 00:12:01
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#if !defined(EA_8BB11D3B_4446_4502_B637_A81DD466EAB0__INCLUDED_)
#define EA_8BB11D3B_4446_4502_B637_A81DD466EAB0__INCLUDED_

#include "ofMain.h"
#include "ofxCv.h"

#include "ShapeUtils.h"


class ofxPAR_Control
{

public:
	ofxPAR_Control();
	virtual ~ofxPAR_Control();

  void setId(int id) { this->id = id;  }

    virtual void draw() = 0;
	
    virtual void setColor(const ofColor &newColor) { color = newColor; }

    virtual bool contains(float x, float y) = 0;
    virtual bool contains(const ofPoint &point) {
        return contains(point.x, point.y);
    }

    virtual bool onInteraction(float x, float y) = 0;
    virtual bool onInteraction(const ofPoint &point) {
        return onInteraction(point.x, point.y);
    }
	
	
	void setSelection(bool value) {selected = value;};
	bool isSelected() {return selected;};

	int getValue() { return value;};


protected:
	int id;
	string name;
	int value;
	ofColor color;
	ControlType controlType;
	bool selected;

};
#endif // !defined(EA_8BB11D3B_4446_4502_B637_A81DD466EAB0__INCLUDED_)
