///////////////////////////////////////////////////////////
//  ofxPAR_ControlManager.h
//  Implementation of the Class ofxPAR_ControlManager
//  Created on:      14-fev-2015 00:12:00
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#if !defined(EA_32C356F0_BF04_4a90_8981_503DA0A7578F__INCLUDED_)
#define EA_32C356F0_BF04_4a90_8981_503DA0A7578F__INCLUDED_


#include "ofMain.h"
#include "ofxCv.h"


#include "ofxPAR_Control.h"

class ofxPAR_ControlManager
{

public:
	ofxPAR_ControlManager();
	virtual ~ofxPAR_ControlManager();

	void setup();
	void reset();
	void drawDetectorInput(float x, float y, float w, float h);

	
    template <class T>
    void detect(T &img) {
        detect(ofxCv::toCv(img));
    }
    void detect(cv::Mat img);

	bool doControlDetection;
	void toogleControlDetection() { doControlDetection == true ? doControlDetection = false  : doControlDetection = true;};

	void processInteraction(const ofPoint &point);
	void drawControls();

	void drawDebug();

    static const ofColor accent1;
    static const ofColor accent2;



	ofxCv::ContourFinder finder;

	// To help track the controls (erode - edge tracking)
    cv::Mat grayImg;
	cv::Mat canny;
	cv::Mat eroded;
	cv::Mat dilated;
    cv::Mat edgesInput;
    cv::Mat edges;

	vector<ofxPAR_Control *> controlList;

    ofPoint lastInputPoint;

    int BORDER;
    float ALPHA;

	void assignControls();
	bool isButton(size_t i);
	bool isSlider(size_t i);
	bool isSwitch(size_t i);

};
#endif // !defined(EA_32C356F0_BF04_4a90_8981_503DA0A7578F__INCLUDED_)
