///////////////////////////////////////////////////////////
//  ofxPAR_Control_Rectangular.cpp
//  Implementation of the Class ofxPAR_Control_Rectangular
//  Created on:      20-fev-2015 06:54:02
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#include "ofxPAR_Control_Rectangular.h"


ofxPAR_Control_Rectangular::ofxPAR_Control_Rectangular(){

}



ofxPAR_Control_Rectangular::~ofxPAR_Control_Rectangular(){

}


//---------------------------------------------------------
ofxPAR_Control_Rectangular::ofxPAR_Control_Rectangular(const cv::RotatedRect &rotRect)
  : ofxPAR_Control() {
    const cv::Size &s = rotRect.size;
    bool switchHeight = s.width < s.height;

    if (switchHeight) {
        rect.setFromCenter(ofxCv::toOf(rotRect.center), s.height, s.width);
        angle = rotRect.angle + 90;
    } else {
        rect.setFromCenter(ofxCv::toOf(rotRect.center), s.width, s.height);
        angle = rotRect.angle;
    }
}

//---------------------------------------------------------
bool ofxPAR_Control_Rectangular::contains(float x, float y) {
    ofVec2f v = alignPoint(x, y);
    return rect.inside(v.x, v.y);
}

//---------------------------------------------------------
bool ofxPAR_Control_Rectangular::operator==(const ofxPAR_Control_Rectangular &other) {
    // TODO Define constants for thresholds
    return (abs(other.angle - angle) < 10)
        && (abs(other.rect.x - rect.x) < 10)
        && (abs(other.rect.y - rect.y) < 10)
        && (abs(other.rect.width - rect.width) < 10)
        && (abs(other.rect.height - rect.height) < 10);
};

//---------------------------------------------------------
ofVec2f ofxPAR_Control_Rectangular::alignPoint(float x, float y) {
    ofPoint center = rect.getCenter();
    ofVec2f v = ofVec2f(x - center.x, y - center.y);
    v.rotate(-angle);
    v += ofVec2f(rect.x + rect.width / 2, rect.y + rect.height / 2);
    return v;
}