///////////////////////////////////////////////////////////
//  ofxPAR_HandDetector.h
//  Implementation of the Class ofxPAR_HandDetector
//  Created on:      14-fev-2015 00:11:58
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#if !defined(EA_9ACFA9CF_CE78_4a3b_A32A_E3651432CCFB__INCLUDED_)
#define EA_9ACFA9CF_CE78_4a3b_A32A_E3651432CCFB__INCLUDED_

#include "ofxPAR_Actuator.h"

class ofxPAR_HandDetector : public ofxPAR_Actuator
{

public:
	ofxPAR_HandDetector();
	virtual ~ofxPAR_HandDetector();

	//concretes:
	void draw();
	void drawDetectorInput(float x, float y, float w, float h);
	bool detect(const cv::Mat &top, const ofPolyline &paper) ;
	ofPoint getActuatorPoint() { return getFingerPoint(); };
	void setActuatorThresold(int value) { this->fingerThreshold = value;};


private:
   bool findFingers(const ofPolyline &paper);

   ofPoint getFingerPoint();

    ofxCv::ContourFinder topFinder;
    ofxCv::ContourFinder sideFinder;
    cv::Mat topFilled;

    ofPolyline contour;

    vector<size_t> fingers;
    ofPoint fingerPoint;

    bool foundFingerInLast;

	int fingerThreshold;
    float fAlpha;

    cv::Mat elem2x2;
    cv::Mat elem3x3;
    const cv::Point useCenter;

};
#endif // !defined(EA_9ACFA9CF_CE78_4a3b_A32A_E3651432CCFB__INCLUDED_)
