///////////////////////////////////////////////////////////
//  ofxPAR_Infra.h
//  Implementation of the Class ofxPAR_Infra
//  Created on:      14-fev-2015 00:11:55
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#if !defined(EA_9FF63BC7_290C_499e_A326_124443D41749__INCLUDED_)
#define EA_9FF63BC7_290C_499e_A326_124443D41749__INCLUDED_

#include "ofMain.h"
#include "ofxCv.h"

#include "ShapeUtils.h"


class ofxPAR_Infra
{
public:
	ofxPAR_Infra();
	virtual ~ofxPAR_Infra();

	// Virtual functions:
	virtual void detect() = 0;
	virtual void draw() = 0;
	virtual void update() = 0;
	virtual void setup() = 0;
	virtual cv::Mat  getTransformation(int outWidth, int outHeight) = 0;
	virtual ofPolyline getContours() = 0;
	virtual ofPoint unwarpPoint(const ofPoint &point, int outWidth, int outHeight) = 0;


	// Camera:
	ofVideoGrabber getCamera() {return cam;}
	void setCamera(ofVideoGrabber new_cam){ this->cam = new_cam;};
	void setCamera(int w, int h) { this->camWidth = w; this->camHeight = h;};
	ofVideoGrabber cam; // Video Tracking source
	int camHeight;
	int camWidth;

	ofImage unwarped; // RAW image from camera
	ofImage getRawUnwarped() {return unwarped;};

	bool showVideoFeed;
	void toogleVideoFeed();

	bool isInfraFound() {return this->foundInfra;};
	bool foundInfra;

	// Projector elements: 

	// Projector warp points
	vector<cv::Point2f> projectorPoints;	//projection corners on the camera image
    cv::Mat toProjectorMatrix;				//projector transformation matrix (to warp projection)
	bool alignmentComplete;
	int projWidth;
	int projHeight;

	// deal with the projector

	void addCalibrationPoints(int x,int y);
	void resetCalibration() { this->resetProjectorAlignment();};
	void doCalibration();
	void drawProjectionLimits(); // Draw projection limitants;

	// Infra States
	//ofxPAR_Infra_State* actualState;
	//bool setState( AppState new_state);


protected:
	string name;

    void computeProjectorAlignment();
    bool loadProjectorAlignment();
    bool saveProjectorAlignment();
	void resetProjectorAlignment();

	//vector<ofxPAR_Infra_State*> stateList;


};
#endif // !defined(EA_9FF63BC7_290C_499e_A326_124443D41749__INCLUDED_)
