////
///////////////////////////////////////////////////////
//  ofxPAR_State_Play.cpp
//  Implementation of the Class ofxPAR_State_Play
//  Created on:      19-fev-2015 15:32:20
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#include "ofxPAR_State_Play.h"

#include "ofxProjAR.h"
#include "ofxPAR_Infra.h"

#include "ofxPAR_ControlManager.h"


#include "ShapeUtils.h"

using namespace ofxCv;
using namespace cv;

ofxPAR_State_Play::ofxPAR_State_Play(){
	this->name = "[OFXPAR][STATE][PLAY]";
	this->stateType = AppState::PLAY;
}



ofxPAR_State_Play::~ofxPAR_State_Play(){

}





void ofxPAR_State_Play::draw(){

	// Fill projection area, so the camera can track the paper.
	// We cant track what we cant see!! :)

	ofFill();
	ofSetColor(ofColor::white);
	ofRect(0,0,ofGetWidth(), ofGetHeight());

	//---------------------------
	// Draw on the projector
	//---------------------------

	ofPushMatrix();
    ShapeUtils::applyTransform(this->app->m_infra->toProjectorMatrix); // adapta as projees da cmera-projetor
    if (this->app->m_infra->foundInfra) {
        ShapeUtils::applyTransform(
			this->app->m_infra->getTransformation( 
			this->app->m_infra->unwarped.width, this->app->m_infra->unwarped.height
				)
			); // adapta a rea da folha
    }
    app->controlManager.drawControls(); //desenha controles
    ofPopMatrix();



	//   // Outline the paper for debugging
	//   if (debugDraw) {
	//       ofNoFill();
	//       ofSetColor(255, 0, 0);
	//       ofSetLineWidth(2);
	//       paperDetector.getPaper().draw();
	//   }



}


void ofxPAR_State_Play::update(){


	if(this->app->m_infra->cam.isFrameNew()){

		// Look up for infra:
		this->app->m_infra->detect();

		// Do the infra job 
		// in the case of paper --> warp the sheet area;
		this->app->m_infra->update();

		// Do the control manager job
		// Find the physical controls
		// The virtual only controls doesnt net to be detected
        if (this->app->controlManager.doControlDetection) {
            this->app->controlManager.detect(this->app->m_infra->getRawUnwarped());
            this->app->controlManager.doControlDetection = false;
        }

		//Create new camera instance picture to transfer to actuator detector
		
		Mat paperCamMat = toCv(this->app->m_infra->cam);
        Mat paperCamChan = Mat::zeros(this->app->m_infra->cam.height, this->app->m_infra->cam.width, CV_8UC3);
        int fromTo[] = { 1,0 , 1,1 , 1,2 };
        mixChannels(&paperCamMat, 1, &paperCamChan, 1, fromTo, 3);

        //topBackground.update(paperCamChan, foreground);
        //if (handDetector.detect(foreground, paperDetector.getPaper())) {
        //    ofPoint rawPoint = handDetector.getFingerPoint();
        //    controlManager.processInteraction(paperDetector.unwarpPoint(rawPoint, unwarped.width, unwarped.height));
        //}

	}
}


void ofxPAR_State_Play::reprojectPaper(){
}