///////////////////////////////////////////////////////////
//  ofxProjAR.h
//  Implementation of the Class ofxProjAR
//  Created on:      14-fev-2015 00:11:54
//  Original author: Christopher Shneider Cerqueira
///////////////////////////////////////////////////////////

#if !defined(EA_2AA5C11F_24F1_44e1_A3BB_D7D3FF048D86__INCLUDED_)
#define EA_2AA5C11F_24F1_44e1_A3BB_D7D3FF048D86__INCLUDED_


#include "ofMain.h" 
#include "ofxCv.h"

#include "ofxPAR_Infra.h"
#include "ofxPAR_Actuator.h"
#include "ofxPAR_ControlManager.h"
#include "ofxPAR_State.h"




class ofxProjAR
{

public:
	ofxProjAR();
	virtual ~ofxProjAR();

	void standardSetup();
	void standardUpdate();
	void standardDraw();


	// INFRA LINK
	ofxPAR_Infra			*m_infra;


	// ACTUATOR LINK
	ofxPAR_Actuator			*m_actuator;

	// CONTROL MANAGER LINK
	ofxPAR_ControlManager	controlManager;	

	// ProjAR state
	bool setState(AppState newState);
	ofxPAR_State* getActualState() {return this->actualState;};

	bool debug;


private:

	ofxPAR_State *actualState;
	vector<ofxPAR_State*> stateList;

	


};
#endif // !defined(EA_2AA5C11F_24F1_44e1_A3BB_D7D3FF048D86__INCLUDED_)
